# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class CompetApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_compets_phases_get_subresource_compet_subresource(self, cp_no, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_get_subresource_compet_subresource(cp_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param int ph_no:
        :param list[int] ph_no:
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_compets_phases_get_subresource_compet_subresource_with_http_info(cp_no, **kwargs)  # noqa: E501
        else:
            (data) = self.api_compets_phases_get_subresource_compet_subresource_with_http_info(cp_no, **kwargs)  # noqa: E501
            return data

    def api_compets_phases_get_subresource_compet_subresource_with_http_info(self, cp_no, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_get_subresource_compet_subresource_with_http_info(cp_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param int ph_no:
        :param list[int] ph_no:
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cp_no', 'ph_no', 'ph_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_compets_phases_get_subresource_compet_subresource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cp_no' is set
        if ('cp_no' not in params or
                params['cp_no'] is None):
            raise ValueError("Missing the required parameter `cp_no` when calling `api_compets_phases_get_subresource_compet_subresource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cp_no' in params:
            path_params['cpNo'] = params['cp_no']  # noqa: E501

        query_params = []
        if 'ph_no' in params:
            query_params.append(('ph_no', params['ph_no']))  # noqa: E501
        if 'ph_no' in params:
            query_params.append(('ph_no[]', params['ph_no']))  # noqa: E501
            collection_formats['ph_no[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets/{cpNo}/phases', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_compet_collection(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Compet resources.  # noqa: E501

        Permet de récupérer les compétitions. Par défaut on récupère toute la donnée. Pour l&d utiliser le filtre 'compet_light' dans le champs `details[]`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compet_collection(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str competition_type:
        :param str cg_no:
        :param list[str] groups:
        :return: InlineResponse20010
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_compet_collection_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_compet_collection_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_compet_collection_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Compet resources.  # noqa: E501

        Permet de récupérer les compétitions. Par défaut on récupère toute la donnée. Pour l&d utiliser le filtre 'compet_light' dans le champs `details[]`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compet_collection_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str competition_type:
        :param str cg_no:
        :param list[str] groups:
        :return: InlineResponse20010
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['competition_type', 'cg_no', 'groups']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_compet_collection" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'competition_type' in params:
            query_params.append(('competition_type', params['competition_type']))  # noqa: E501
        if 'cg_no' in params:
            query_params.append(('cg_no', params['cg_no']))  # noqa: E501
        if 'groups' in params:
            query_params.append(('groups[]', params['groups']))  # noqa: E501
            collection_formats['groups[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20010',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_compet_item(self, cp_no, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compet_item(cp_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Resource identifier (required)
        :return: CompetJsonldCompet
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_compet_item_with_http_info(cp_no, **kwargs)  # noqa: E501
        else:
            (data) = self.get_compet_item_with_http_info(cp_no, **kwargs)  # noqa: E501
            return data

    def get_compet_item_with_http_info(self, cp_no, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compet_item_with_http_info(cp_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Resource identifier (required)
        :return: CompetJsonldCompet
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cp_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_compet_item" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cp_no' is set
        if ('cp_no' not in params or
                params['cp_no'] is None):
            raise ValueError("Missing the required parameter `cp_no` when calling `get_compet_item`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cp_no' in params:
            path_params['cpNo'] = params['cp_no']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets/{cpNo}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CompetJsonldCompet',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
